#define KEY_RETURN		13
#define KEY_BACKSPACE_1		8
#define KEY_BACKSPACE_2		127


/** widget functions accessible through widget_function() **/

#define FUNCTION_FORMAT		0
#define FUNCTION_INITIALIZE	1
#define FUNCTION_PARSE		2
#define FUNCTION_LOAD		3
#define FUNCTION_STORE		4
#define FUNCTION_CLEAN		5
#define FUNCTION_SETUP		6
#define FUNCTION_EDIT		7
#define FUNCTION_SELECT		8
#define FUNCTION_MOTION		9
#define FUNCTION_RELEASE	10
#define FUNCTION_EXECUTE	11
#define FUNCTION_DRAW		12
#define FUNCTION_HELP		13
#define FUNCTION_DUMP		14

/** permanent widget indicies **/

#define CONTROL_X_NONE		241
#define CONTROL_X_ALL		240
#define CONTROL_X_BASE		0

/** format_info/widget_info defined indices **/

#define IS_SELECTABLE		0	/** status indices **/
#define IS_ACTIVATABLE		1
#define IS_EDITABLE		2
#define IS_MOTION_UPDATED	3
#define IS_MOTION_ACTIVE	4
#define IS_TIMER_ACTIVE		5
#define IS_BUFFERABLE		6
#define IS_COMPOSITE		7
#define IS_EVENT		8

#define	MAX_STATUS		9

#define EVENT_NOTHING		0
#define EVENT_PRESS		1
#define EVENT_MOTION		2
#define EVENT_RELEASE		3
#define EVENT_TIMER		4

#define THICKNESS_SHADOW	0	/** thickness indices **/
#define THICKNESS_ACTIVE	1
#define THICKNESS_SELECT	2

#define	MAX_THICKNESS		3

#define	GC_BODY			0	/** GC indices **/
#define	GC_BODY_INV		1
#define	GC_FONT_FIRST		2
#define	GC_FONT_SECOND		3
#define	GC_BACKGROUND		9

#define	MAX_GCS			10

#define	FONT_FIRST		0	/** font indices **/
#define	FONT_SECOND		1

#define	MAX_FONTS		5

#define	MAX_POINTS		8

#define	MAX_RELATIVES		3

#define	MAX_LABELS		12
#define	MAX_LABEL_LENGTH	50
#define	MAX_STRING_LENGTH	50


/** enumerators to define widget's current operation mode **/

#define MODE_NORMAL		0
#define MODE_SELECT 		1	
#define MODE_ACTIVE 		2	
#define MODE_SPECIAL 		3	


/** remainder of format_info/widget_info array sizes **/

#define	MAX_DATA		8
#define	MAX_STATES		16
#define	MAX_VALUES		3
#define	MAX_GRAPHICS		6

/** global preference enumerators **/

#define BUFFER_NONE		0	/** use_buffer type **/
#define BUFFER_WIDGET		1
#define BUFFER_PANEL		2

#define BUFFER_NORMAL		1	/** IS_BUFFERABLE type **/
#define BUFFER_CLEAR		2

/** format_info/widget_info enumerators **/

#define EDITABLE_NEVER		0	/** IS_EDITABLE status **/
#define EDITABLE_PARTIAL	1
#define EDITABLE_FULL		2
#define EDITABLE_ACTION		3

#define MOTION_NEVER		0	/** IS_MOTION_ACTIVE status **/
#define MOTION_EXECUTE		1
#define MOTION_UPDATE		2

#define	FONT_0			0	/** Win->fonts font index **/
#define	FONT_1			1
#define	FONT_2			2
#define	FONT_3			3
#define	FONT_4			4

#define	FONT_SMALL		0	/** Win->fonts font index **/
#define	FONT_MEDIUM		1
#define	FONT_LARGE		2
#define	FONT_HUGE		3
#define	FONT_FIXED		4


/** enumerators to indicate editing state in xxxx_edit() **/

#define	EDIT_BEGIN		0
#define	EDIT_PROCESS		1
#define	EDIT_FINISH		2


/** enumerators for draw_generic_box() **/

#define BULGE_IN		0	/** inward or outward bulge **/
#define BULGE_OUT		1

#define BULGE_KEEP		0	/** switch bulge when selected **/
#define BULGE_SWAP		1

#define ACTIVE_HIDE		0	/** display surround when active **/
#define ACTIVE_SHOW		1


/** enumerators for nexus placement of widgets **/

#define LOCATE_BELOW		-1
#define LOCATE_ABOVE		-2
#define LOCATE_SAME		-3
#define LOCATE_RIGHT		-4
#define LOCATE_LEFT		-5
#define LOCATE_CENTER		-6
#define LOCATE_OVERLAY_BELOW	-7
#define LOCATE_OVERLAY_ABOVE	-8
#define LOCATE_OVERLAY_SAME	-9
#define LOCATE_OVERLAY_RIGHT	-10
#define LOCATE_OVERLAY_LEFT	-11
#define LOCATE_OVERLAY_CENTER	-12

/** enumerators for nexus dimensioning of widgets **/

#define DIMENSION_SAME		-1
#define DIMENSION_TAFFY		-2
#define DIMENSION_PANEL		-3

/** enumerators for label placement **/

#define LABEL_NONE		0
#define LABEL_NORTH		1
#define LABEL_NORTH_WEST	2
#define LABEL_NORTH_EAST	3
#define LABEL_SOUTH		4
#define LABEL_SOUTH_WEST	5
#define LABEL_SOUTH_EAST	6
#define LABEL_EAST		7
#define LABEL_WEST		8
#define LABEL_CENTER		9
#define LABEL_GENERIC		10

/** various nexus links **/

#define LINK_BASIC		0
#define LINK_WIDTH		1
#define LINK_HEIGHT		2
#define LINK_X			3
#define LINK_Y			4

#define MAX_LINKS		5

/** enumerator to indicate no panel selected **/

#define PANEL_NONE		-1

/** a subtle one - booleans **/

#define TRUE			1
#define FALSE			0


/** here we start the defines for the Win structure **/

/** default window size and position **/

#define DEFAULT_WIDTH		300
#define DEFAULT_HEIGHT		300
#define DEFAULT_XPOS		0	
#define DEFAULT_YPOS		0


/** default delay between Win->update_event's (one second?) **/

#define BASE_DELAY		10000


/** default fonts **/

#define DEFAULT_FONT_0	"-*-*-bold-r-*-*-12-*-*-*-p-*-iso8859-1"
#define DEFAULT_FONT_1	"-*-*-bold-r-*-*-16-*-*-*-p-*-iso8859-1"
#define DEFAULT_FONT_2	"-*-*-bold-r-*-*-18-*-*-*-p-*-iso8859-1"
#define DEFAULT_FONT_3	"-*-*-bold-r-*-*-24-*-*-*-p-*-iso8859-1"
#define DEFAULT_FONT_4	"-*-lucidatypewriter-medium-r-*-*-12-*-*-*-m-*-*-1"

/** font limits **/

#define FONT_MAX_LIMIT		20
#define FONT_DEFAULT_LIMIT	5
#define FONT_MIN_LIMIT		3

/** maximum number of typesets **/

#define TYPESET_MAX_LIMIT		FONT_MAX_LIMIT

/** maximum number of colors **/

#define COLOR_USABLE_MAX_LIMIT		256
#define COLOR_ORABLE_MAX_LIMIT		16
#define COLOR_CONTROL_MAX_LIMIT		256

/** maximum number of spectra **/

#define SPECTRUM_MAX_LIMIT		COLOR_CONTROL_MAX_LIMIT

/** default number of colors **/

#define COLOR_USABLE_DEFAULT_LIMIT	4
#define COLOR_ORABLE_DEFAULT_LIMIT	0
#define COLOR_CONTROL_DEFAULT_LIMIT	15

/** minimum number of colors **/

#define COLOR_USABLE_MIN_LIMIT		4
#define COLOR_ORABLE_MIN_LIMIT		0
#define COLOR_CONTROL_MIN_LIMIT		13

/** generic color enumerators **/

#define COLOR_CTRL_BACK			0
#define COLOR_CTRL_SHADOW		1
#define COLOR_CTRL_HIGH			2
#define COLOR_CTRL_SURFACE		3
#define COLOR_CTRL_SURFACE_INV		4
#define COLOR_CTRL_DARK  		5
#define COLOR_CTRL_DARK_INV		6
#define COLOR_CTRL_ACTIVE		7
#define COLOR_CTRL_TEXT_1		8
#define COLOR_CTRL_TEXT_2		9
#define COLOR_CTRL_TEXT_3		10
#define COLOR_CTRL_AUX_1		11
#define COLOR_CTRL_AUX_2		12
#define COLOR_CTRL_AUX_3		13
#define COLOR_CTRL_AUX_4		14

/** some alternate color enumerators **/

#define COLOR_CTRL_SURFACE_1		COLOR_CTRL_AUX_1
#define COLOR_CTRL_SURFACE_INV_1	COLOR_CTRL_AUX_2
#define COLOR_CTRL_SURFACE_2		COLOR_CTRL_AUX_3
#define COLOR_CTRL_SURFACE_INV_2	COLOR_CTRL_AUX_4


/** default dimensions for undefined widgets **/

#define DEFAULT_DIMENSION_X		120
#define DEFAULT_DIMENSION_Y		25
#define DEFAULT_SPACING_X		15
#define DEFAULT_SPACING_Y		15
#define DEFAULT_DELTA_X			15
#define DEFAULT_DELTA_Y			15


/** default thicknesses **/

#define DEFAULT_SHADOW_THICKNESS	3
#define DEFAULT_ACTIVE_THICKNESS	2
#define DEFAULT_SELECT_THICKNESS	2

/** default setup file **/

#define DEFAULT_SETUP_FILENAME		"xpip.cf"

/** default directories for various files (unused) **/

#define DEFAULT_HELP_DIRECTORY		"./help"
#define DEFAULT_BITMAP_DIRECTORY	"./bitmaps"


/** maximum number in global arrays **/ 

#define MAX_PANELS	                20
#define MAX_CONTROLS                    200
#define MAX_FORMATS	                50
