#define MAX(x,y)               (((x)>(y)) ? (x) : (y))
#define MIN(x,y)               (((x)>(y)) ? (y) : (x))

  struct font_info
  {
    XFontStruct		*font;
    char		*fontname,
			is_fixed_width;
    XPoint		dimension;	
  };

  struct xwindow_info
  {
    Display			*display;
    Window	 		window;
    XEvent			event;
    int 			depth,
				screen;
    XSizeHints 			hint;
    XWMHints			xwmh;
    Visual			*visual;
    XImage			*image;
    XSetWindowAttributes	attrib;
    Colormap 			colormap;
    Pixmap			pix_aux[5];

    short			font_limit;
    struct font_info		*fonts[FONT_MAX_LIMIT];

    XPoint			mouse;
    int				update_event;

    char			display_name[MAX_STRING_LENGTH];
    char			window_title[MAX_STRING_LENGTH];
    short			color_orable_limit,
				color_usable_limit,
				color_widget_limit;
    short			use_dedicated_colormap;
    GC				hue_orable[COLOR_ORABLE_MAX_LIMIT],
 				hue_usable[COLOR_USABLE_MAX_LIMIT],
				hue_widget[COLOR_CONTROL_MAX_LIMIT];
    XColor 			color_orable[COLOR_ORABLE_MAX_LIMIT],
				color_usable[COLOR_USABLE_MAX_LIMIT],
                                color_widget[COLOR_CONTROL_MAX_LIMIT];

    short			spectrum_count,
				spectrum_indices[SPECTRUM_MAX_LIMIT],
				spectrum_defs[SPECTRUM_MAX_LIMIT][3];
    char			spectrum_names[SPECTRUM_MAX_LIMIT][MAX_STRING_LENGTH];

    short			typeset_count,
				typeset_indices[TYPESET_MAX_LIMIT];
    char			typeset_names[TYPESET_MAX_LIMIT][MAX_STRING_LENGTH];
  };

  struct graphic_info
  {
    char		filename[MAX_STRING_LENGTH],
			is_bitmap;
    short		gc;
    unsigned int	width,
			height;
    Pixmap		pixmap;
  };

  extern struct panel_info;

  struct widget_info
  {
    char                *name,			/** names and links **/
			*comment,
			*link_names[MAX_LINKS];

    unsigned char	format,			/** common status fields **/
			subformat,
			superformat,
			mode,
			flag,
			enable,
			reserve,
			user,
			locate,
			status[MAX_STATUS];	

    void		*relatives[MAX_RELATIVES];
    struct widget_info	*background;
    struct panel_info	*panel;

    Window		drawable;		/** destination **/

    XPoint		size,			/** common position fields **/
			position,
			real_position,
			spacing,
			delta,
			cursor,
			locate_offset,
			text_offset[MAX_STATES],
			points[MAX_POINTS],
			bound_offset,
			bound_size;

    unsigned char	thickness[MAX_THICKNESS];

    char                *label,			 /** labels **/
			*labels[MAX_LABELS],
			*string,
			**superlabels;

    char		fonts[MAX_FONTS],	/** indices for fonts and gcs **/
			gcs[MAX_GCS];

    int			state_count,		/** integers **/
			state,
			next_state,
			states[MAX_STATES];

    int			value_count;		/** doubles **/
    double              value,
			next_value,
			values[MAX_VALUES],
			minimum, maximum;

    short		data[MAX_DATA];		/** generic data **/
    double		data_float[MAX_DATA];	/** generic data **/

    short		graphic_count;		/** pixmap information **/
    struct graphic_info	*graphics[MAX_GRAPHICS];
  };


  struct panel_info
  {
    char                name[30];
    struct widget_info *widgets[MAX_CONTROLS],
			*base_widget;
    short               widget_count;
    short               current_widget_index,
			index;
    XPoint		size,
			position;
    Window	 	window;
    Pixmap		pixmap;
    unsigned char	is_open,
			is_active,
			is_locked,
			is_drawn;
    void		*pointer;
  };

  struct console_info
  {
    struct panel_info	*panels[MAX_PANELS],
			*panel,
			*base_panel,
			*next_panel,
			*event_panel,
			*select_panel;
    struct widget_info	*active_widget,
			*select_widget,
                        *dummy_widget,
                        *formats[MAX_FORMATS],
                        *back_formats[MAX_FORMATS];
    short		panel_count,
			active_mode,
			select_mode;
    Pixmap		pixmap;
    char		panel_files[MAX_PANELS][75];
  };

  struct master_info
  {
    char	widget_setup_file[200],
		bitmap_directory[200],
		help_directory[200];
    int		time_delay;
    short	allow_drag,
		use_buffer,
		use_motion_highlights,
		use_offset_activate,
		use_v_2_1_definitions;
    double	last_value;
  };

typedef struct graphic_info Graphic;
typedef struct widget_info Widget;
typedef struct panel_info Panel;

extern char *strdup();

extern Widget *handle_widget_search(),
              *handle_button_press(),
              *handle_button_release(),
              *handle_button_motion(),
              *handle_keypress(),
              *strong_widget_search(),
              *get_named_widget_label(),
              *get_named_widget(),
              *get_flagged_widget(),
              *create_widget();

extern char *strdup();

extern double get_named_widget_value();

extern Panel *get_named_panel();

extern struct xwindow_info *Win;

extern struct console_info *Console;

extern struct master_info *Master;

extern unsigned char Grey_Palette[5][8];

extern unsigned char ColorFixed[][3],	
                     ColorOrable[][3],
                     ColorControl[][3],
                     ColorUsable[][3];

extern char Spectrum[][MAX_STRING_LENGTH];
extern char Typeset[][MAX_STRING_LENGTH];
